/* cg.hh*/

#ifndef _CG_HH_
#define _CG_HH_

#include <list>
#include "c.hh"
#include "archi.hh"
#include "tp.hh"
#include "pu.hh"
#include "sched.hh"
#include "emit.hh"
#include "flags.hh"

class CG {

public:
  CG();
  ~CG();
  static void initialize(int, char **);
  static void finalize(void);
  void function(lcc::Symbol, lcc::Symbol *, lcc::Symbol *, int);
  lcc::Node gen(lcc::Node);
  void emit(lcc::Node, char *);
  static Emitter* get_emitter();
private:

  static Flags flags;
  static bool b_initialized;
  static Architecture *architecture;
  static Emitter *emitter;
  short rank;

  static char* archi;
  static TimeProfile *empty_time_profile;
  std::list< std::pair< Schedule *, DAG * > > schedule;
};

#endif //_CG_HH_
