#ifndef __GAFITNESS_HH__
#define __GAFITNESS_HH__

#include <iostream>


namespace GA
{


/**
 * TODO
 */
template<typename T, class LesserFitnessPolicy>
class Fitness
{
  
public:
  Fitness(const T& _value = T()) : value(_value) {};
  ~Fitness() {};
  
  const T& get_value() const { return value; };
  void set_value(const T& _value) { value = _value; };
  
  bool is_less_than(const Fitness<T, LesserFitnessPolicy>& f) const;
  bool is_equal_to(const Fitness<T, LesserFitnessPolicy>& f) const;
  
private:
  T value;
};


template<typename T, class LesserFitnessPolicy>
bool Fitness<T, LesserFitnessPolicy>::is_less_than(const Fitness<T, LesserFitnessPolicy>& f) const
{
  return LesserFitnessPolicy::is_less_than(value, f.get_value());
}

template<typename T, class LesserFitnessPolicy>
bool Fitness<T, LesserFitnessPolicy>::is_equal_to(const Fitness<T, LesserFitnessPolicy>& f) const
{
  return (value == f.get_value());
}


};


template<typename T, class LesserFitnessPolicy>
std::ostream& operator<<(std::ostream& o, const GA::Fitness<T, LesserFitnessPolicy>& f)
{
  o << f.get_value();
  return o;
}


template<typename T, class LesserFitnessPolicy>
bool operator< (const GA::Fitness<T, LesserFitnessPolicy>& f1, const GA::Fitness<T, LesserFitnessPolicy>& f2)
{
  return f1.is_less_than(f2);
}

template<typename T, class LesserFitnessPolicy>
bool operator> (const GA::Fitness<T, LesserFitnessPolicy>& f1, const GA::Fitness<T, LesserFitnessPolicy>& f2)
{
  return f2.is_less_than(f1);
}

template<typename T, class LesserFitnessPolicy>
bool operator== (const GA::Fitness<T, LesserFitnessPolicy>& f1, const GA::Fitness<T, LesserFitnessPolicy>& f2)
{
  return f1.is_equal_to(f2);
}

template<typename T, class LesserFitnessPolicy>
bool operator<= (const GA::Fitness<T, LesserFitnessPolicy>& f1, const GA::Fitness<T, LesserFitnessPolicy>& f2)
{
  return (f1.is_less_than(f2) || f1.is_equal_to(f2));
}

template<typename T, class LesserFitnessPolicy>
bool operator>= (const GA::Fitness<T, LesserFitnessPolicy>& f1, const GA::Fitness<T, LesserFitnessPolicy>& f2)
{
  return (f2.is_less_than(f1) || f1.is_equal_to(f2));
}


#endif //__GAFITNESS_HH__
