#include "ilpd.hh"

ILPD::ILPD(DAG _dag, std::ofstream & _f)
{
  graph_traits< DAG >::vertex_iterator vi, vi_end;
  int nr_v = 0;
  graph_traits< DAG >::edge_iterator ei, ei_end;
  int nr_e = 0;
  lcc::Node p;

  _f << "param: G : OPG ODG :=" << std::endl;
  for(tie(vi, vi_end) = vertices(_dag); vi != vi_end; ++vi) {
    nr_v++;
    p = get_lcc_node(*vi, _dag);
    successor_iterator pi, pi_end;
    int outdeg = 0;
    for(tie(pi, pi_end) = successors(*vi, _dag); pi != pi_end; ++pi) {
      outdeg++;
    }
    //Node id
    _f << "  " << *vi  
      //Operator id
       << "\t" << p->op 
      //Node out-degree
       << "\t" <<  outdeg
      //Node name
       << "\t# " << lcc::opname(p->op) 
       << std::endl;
  }
  _f << ";" << std::endl << std::endl;

  _f << "set EG0 :=" << std::endl;
  for(tie(ei, ei_end) = edges(_dag); ei != ei_end; ++ei) {
    nr_e++;
    if(get_edge_type(*ei, _dag) == KID0){
      size_t p_id = source(*ei,_dag), q_id = target(*ei,_dag);
      _f << "  (" << p_id << "," << q_id << ")" << std::endl;
    }
  }
  _f << ";" << std::endl << std::endl;

  _f << "set EG1 :=" << std::endl;
  for(tie(ei, ei_end) = edges(_dag); ei != ei_end; ++ei) {
    if(get_edge_type(*ei, _dag) == KID1){
      size_t p_id = source(*ei,_dag), q_id = target(*ei,_dag);
      _f << "  (" << p_id << "," << q_id << ")" << std::endl;
    }
  }
  _f << ";" << std::endl << std::endl;

  _f << "set EGDEP :=" << std::endl;
  for(tie(ei, ei_end) = edges(_dag); ei != ei_end; ++ei) {
    if(get_edge_type(*ei, _dag) == DDEP){
      size_t p_id = source(*ei,_dag), q_id = target(*ei,_dag);
      _f << "  (" << p_id << "," << q_id << ")" << std::endl;
    }
  }
  _f << ";" << std::endl << std::endl;



  _f << "# |G| = " << nr_v << " |E| = " << nr_e << std::endl << std::endl;

}

ILPD::~ILPD()
{
}
