#ifndef __NODE_HH__
#define __NODE_HH__

#include <set>
#include <assert.h>
#include "pudag.hh"
#include "pattern.hh"
#include "nodeattr.hh"

typedef std::map< pvertex_id, vertex_id > node_map_t;
typedef struct { 
  node_map_t iso_map;  //Isomorphism map
  node_map_t arg_map;  //Argmument map
  vertex_id root;
} iso_map_s;

//void print_iso_map(iso_map_s & im);

class Node {

public:
  Node() {}
  ~Node() {}
  virtual std::pair< bool, std::set< int > >
  get_residence_class(vertex_id) = 0;
  virtual NodeAttr *get_node_attr(void) const = 0;
  virtual size_t get_hash(void) const = 0;

};

#endif //__NODE_HH__
